#ifndef ADABOOSTM1_INC
#define ADABOOSTM1_INC

#include "Boost.h"

/** 
 * the AdaBoostM1 Trainer . This is the Boosting algorithm
 * AdaBoostM1 as described in [Freund, Schapire (1996)].
 * 
 * Here we must differentiate between two cases. The two class and multi 
 * (... more than two ... ) class problems. If we have two classes, than
 * the actual target is not a vector of size two, but a real who takes
 * two particular values tabclasses[0] and tabclasses[1]. 
 * In a multi-class ( > 2) problem, the target is a vector
 * in which the index with the maximal value is the target class. 
 *
 * @author Bison Ravi (francois.belisle@idiap.ch)
 */
class AdaBoostM1 : public Boost
{
 public:

    real tabclasses[2];

    AdaBoostM1( BoostMachine*, DataSet* );
    
    virtual ~AdaBoostM1();
    
    /** definition of the virtual function in #Trainer# */
    virtual void train( List* measurers ); //trains the algos and sets the betas.
   
};

#endif  
