#ifndef ADABOOSTM1_MACHINE_INC
#define ADABOOSTM1_MACHINE_INC

#include "BoostMachine.h"

/** 
 * The AdaBoostM1 Machine sets the outputs accordingly 
 * to the algorithm AdaBoost.M1 described in [Freund, Shapire(1996)]
 *
 * @author Bison Ravi (francois.belisle@idiap.ch)
 */
class AdaBoostM1Machine : public BoostMachine
{
 public:

    int* predicted_outcome;

    AdaBoostM1Machine( Trainer**, int n_trainers_, int n_examples_, List** trainers_measurers_ );
    
    virtual ~AdaBoostM1Machine();

    /** definition of the virtual functions in #Machine# */
    virtual void forward( List* inputs );
    virtual void reset();
};
  
#endif
