#ifndef ADABOOSTM2_INC
#define ADABOOSTM2_INC


#include "Boost.h"

/** 
 * the AdaBoostM2 Trainer. This differs from AdaboostM1 trainer by 
 * extending the communication between the boosting algorithm and the 
 * weaklearner. The Trainer here can choose a set of "possible" labels
 * for the outputs. This boosting algorithm not only focuses on the
 * "hard" examples, it also concentrates on the examples of the CLASSES
 * that are hard to classify. The WeakLearners have to be
 * of the form f: X x Y --> [0,1]
 * 
 * @author Bison Ravi (francois.belisle@idiap.ch)
 */
class AdaBoostM2 : public Boost
{
 public:

    real* beta; //needed to compute h_fin 
    real* W; 
    real* q;

    AdaBoostM2( BoostMachine*, DataSet* );

    virtual ~AdaBoostM2();
     
    /** definition of the virtual function of #Trainer# */
    virtual void train( List* measurers ); //trains the algos and sets the betas.
    
};

#endif  
