#ifndef ADABOOSTM2_MACHINE_INC
#define ADABOOSTM2_MACHINE_INC


#include "BoostMachine.h"



/** 
 * The AdaBoostM2 Machine sets the outputs accordingly 
 * to the algorithm AdaBoost.M2 described in [Freund, Shapire(1996)]
 *
 * @author Bison Ravi (francois.belisle@idiap.ch)
 */
class AdaBoostM2Machine : public BoostMachine
{
  public:

    real* B_dist;
    real* B_inter;

    AdaBoostM2Machine( Trainer**, int n_trainers_, int n_examples_ , List** );
    
    virtual ~AdaBoostM2Machine();
    
    /** defintion of the virtual functions of #Machine# */
    virtual void forward( List* inputs );
    virtual void reset();
};

#endif  
