#include "BaggingMachine.h"
#include "random.h"

BaggingMachine::BaggingMachine(Trainer **trainers_, int n_trainers_, List** trainers_measurers_)
  
{
  // Boaf
  trainers = trainers_;
  trainers_measurers = trainers_measurers_;
  n_trainers = n_trainers_;

  n_outputs = trainers[0]->machine->n_outputs;
  addToList(&outputs, n_outputs, (real *)xalloc(sizeof(real)*n_outputs));

}

void BaggingMachine::reset()
{
  for (int i=0;i<n_trainers;i++)
    trainers[i]->machine->reset();
}

void BaggingMachine::init()
{
  reset();
}

void BaggingMachine::forward(List *inputs)
{
  real* pout = (real*)outputs->ptr;
  for (int j=0;j<n_outputs;j++)
    *pout++ = 0;
  for (int i=0;i<n_trainers;i++) {
    trainers[i]->machine->forward(inputs);
    pout = (real*)outputs->ptr;
    List* from = trainers[i]->machine->outputs;
    real *from_ptr = (real*)from->ptr;
    int index_from = 0;
    for (int j=0;j<n_outputs;j++) {
      if (index_from == from->n) {
        from = from->next;
        from_ptr = (real*)from->ptr;
        index_from = 0;
      }
      *pout++ += *from_ptr++;
      index_from++;
    }
  }
  pout = (real*)outputs->ptr;
  for (int j=0;j<n_outputs;j++)
    *pout++ /= (real)n_trainers;
}

void BaggingMachine::loadFILE(FILE *file)
{
  for (int i=0;i<n_trainers;i++)
    trainers[i]->loadFILE(file);
}

void BaggingMachine::saveFILE(FILE *file)
{
  for (int i=0;i<n_trainers;i++)
    trainers[i]->saveFILE(file);
}

BaggingMachine::~BaggingMachine()
{
  freeList(&outputs,true);
}
