#ifndef BAYES_CLASSIFIER_INC
#define BAYES_CLASSIFIER_INC


#include "Trainer.h"
#include "BayesClassifierMachine.h"

/** A multi class bayes classifier -- train each class with a  
    seperate trainer for distribution. When testing, the predicted class
    correspond to the trainer giving the maximum output, weighted by
    its prior probability.
 
    @author Bison Ravi (francois.belisle@idiap.ch)
    @author Samy Bengio (bengio@idiap.ch)
*/
class BayesClassifier : public Trainer
{
  public:
    
    /// the bayes machine
    BayesClassifierMachine* bayesmachine; 
    
    /// the number of different classes
    int n_classes;
    
    /// all the example indices of each class.
    int** classes; 
    ///the number of examples per class.
    int* classes_n; 

    BayesClassifier( BayesClassifierMachine* , DataSet*);
    virtual ~BayesClassifier();

    virtual void train( List* );

};

#endif
