#ifndef BOOST_INC
#define BOOST_INC

#include "GMTrainer.h"
#include "BoostMachine.h"
#include "WeightedMseCriterion.h"

/** 
 * the Boost Trainer. The class emulates a Boosting Algorithm by taking
 * a BoostMachine, composed of several WeakLearners, and training or testing 
 * each of them on the data contained in the DataMachine.
 * 
 * @author Bison Ravi (francois.belisle@idiap.ch)
 */
class Boost : public Trainer 
{
  public:
  
    BoostMachine* boostmachine; //the boosting machine

    bool weighting; //wether sampling or weighting is used

    real* beta; //needed to compute the final mapping
    int* subset; //instead of using directly the dataset.
    
    Boost( BoostMachine*, DataSet* );
    virtual ~Boost();

};
  
#endif
