#include "BoostMachine.h"

BoostMachine::BoostMachine( Trainer** trainers_, int n_trainers_, int n_examples_, 
			    List** trainers_measurers_)
{
  trainers = trainers_;
  n_trainers = n_trainers_;
  n_examples = n_examples_;
  trainers_measurers = trainers_measurers_;

  n_outputs = 1; //boosting is for classification!
  
  addToList( &outputs, n_outputs, ( real* )xalloc( n_outputs * sizeof( real )));
  trainer_outputs = trainers[ 0 ]->machine->n_outputs;
}

BoostMachine::~BoostMachine()
{
  free( outputs->ptr );
  freeList( &outputs );
  free( sum_of_beta );
  free( prob_dist );
  free( prob_inter );
}


void BoostMachine::setTrainer( Trainer* trainer_ )
{
  trainerBK = trainer_;
}

void BoostMachine::init()
{
  reset();
}

  
void BoostMachine::reset()
{
  for( int i = 0; i < n_trainers; i++ )
    trainers[ i ]->machine->reset();
}

void BoostMachine::loadFILE( FILE* file )
{
  for( int i = 0; i < n_trainers; i++ )
    trainers[ i ]->loadFILE( file );
}

void BoostMachine::saveFILE( FILE* file )
{
  for( int i = 0; i < n_trainers; i++ )
    trainers[ i ]->saveFILE( file );
}

