#include "BoostingMachine.h"
#include "random.h"

BoostingMachine::BoostingMachine(Trainer **trainers_, int n_trainers_, List** trainers_measurers_)
  
{
  // Boaf
  trainers = trainers_;
  trainers_measurers = trainers_measurers_;
  n_trainers = n_trainers_;

  n_outputs = trainers[0]->machine->n_outputs;
  addToList(&outputs, n_outputs, (real *)xalloc(sizeof(real)*n_outputs));

  weights = NULL;
}

void BoostingMachine::reset()
{
  for (int i=0;i<n_trainers;i++)
    trainers[i]->machine->reset();
}

void BoostingMachine::init()
{
  reset();
}

void BoostingMachine::forward(List *inputs)
{
  if(!weights)
  {
    warning("BoostingMachine: no weights, no forward...");
    return;
  }

  real* pout = (real*)outputs->ptr;
  for(int j = 0; j < n_outputs; j++)
    *pout++ = 0;
  
  for(int i = 0; i < n_trainers; i++)
  {
    trainers[i]->machine->forward(inputs);
    pout = (real*)outputs->ptr;
    real *pout_i = (real*)trainers[i]->machine->outputs->ptr;
    real z = weights[i];
//    print("[%g x %g] ", z, *pout_i);
    for (int j = 0; j < n_outputs; j++)
      *pout++ += z * *pout_i++;
  }
//  print("\n");
}

void BoostingMachine::loadFILE(FILE *file)
{
  //DEBUG: sauver weights
  for (int i=0;i<n_trainers;i++)
    trainers[i]->loadFILE(file);
}

void BoostingMachine::saveFILE(FILE *file)
{
  for (int i=0;i<n_trainers;i++)
    trainers[i]->saveFILE(file);
}

BoostingMachine::~BoostingMachine()
{
  freeList(&outputs,true);
}
