#include "ClassBoostingMeasurer.h"

ClassBoostingMeasurer::ClassBoostingMeasurer(ClassFormat *class_format_, FILE *file_) : BoostingMeasurer(file_)
{
  class_format = class_format_;
}

ClassBoostingMeasurer::ClassBoostingMeasurer(ClassFormat *class_format_, const char *filename) : BoostingMeasurer(filename)
{
  class_format = class_format_;

}

void ClassBoostingMeasurer::init()
{
  Measurer::init();

  measure = xalloc(sizeof(real)*4);
    
  real *r_measure = (real *)measure;
  erreur = r_measure;
  erreur_c = r_measure+1;

  reset();
}

void ClassBoostingMeasurer::measureEx()
{
  int c_obs = class_format->getOutputClass(inputs);
  int c_des = class_format->getTargetClass(data->targets);

  if(c_obs != c_des) {
    *erreur_c += weights[current_example];
    status[current_example++] = -1;
  } else {
    status[current_example++] = 1;
  }

}

void ClassBoostingMeasurer::measureIter()
{
  *erreur = *erreur_c;
  beta = *erreur/(1. - *erreur);

  fprintf(file, "%g ==> %g for beta\n", *erreur, beta);
  fflush(file);
  reset();
}

void ClassBoostingMeasurer::reset()
{
  *erreur_c = 0;
  current_example = 0;
}

ClassBoostingMeasurer::~ClassBoostingMeasurer()
{
  free(measure);
}
