#ifndef CLASS_BOOSTING_MEASURER_INC
#define CLASS_BOOSTING_MEASURER_INC

#include "BoostingMeasurer.h"
#include "DataSet.h"
#include "ClassFormat.h"

/** Compute the classification error (in %) for #BoostingMachine#
    of the #inputs# with respect to the #targets# of #data#.

    The format of the class is given with a #ClassFormat#.

    #measure# = {<[real] error proportion>, <[real] current number of errors>}

    @author Samy Bengio (bengio@idiap.ch)
*/
class ClassBoostingMeasurer : public BoostingMeasurer
{
  public:
    real *erreur;
    real *erreur_c;
    int current_example;
    ClassFormat *class_format;

    //-----

    ///
    ClassBoostingMeasurer(ClassFormat *class_format_, FILE *file_);
    ///
    ClassBoostingMeasurer(ClassFormat *class_format_, const char *filename);

    //-----

    virtual void init();
    virtual void reset();
    virtual void measureEx();
    virtual void measureIter();

    virtual ~ClassBoostingMeasurer();
};

#endif
