#ifndef CONFIDENCE_BAG_MEASURER_INC
#define CONFIDENCE_BAG_MEASURER_INC

#include "Measurer.h"
#include "DataSet.h"
#include "BaggingMachine.h"
#include "int_real.h"

class ConfidenceBagMeasurer : public Measurer
{
  public:

    // confidence level should be between 0 and 1
    real level;

    BaggingMachine* b_machine;

    // temp vector for sorting
    Int_real* to_sort;

    DataSet *data;

    ConfidenceBagMeasurer(BaggingMachine* b_machine_, DataSet *data_, FILE *file_, real level_);
    ConfidenceBagMeasurer(BaggingMachine* b_machine_, DataSet *data_, const char *filename, real level_);

    virtual void init();
    virtual void reset();
    virtual void measureEx();
    virtual void measureIter();

    virtual ~ConfidenceBagMeasurer();
};

#endif
