#ifndef EDIT_DISTANCE_MEASURER_INC
#define EDIT_DISTANCE_MEASURER_INC

#include "Measurer.h"
#include "EditDistance.h"
#include "DataSet.h"

/** This class can be used to measure and print an #EditDistance# object.
    It is used for instance in a speech recognition experiment.

    @author Samy Bengio (bengio@idiap.ch)
*/
class EditDistanceMeasurer : public Measurer
{
  public:
    /// the #EditDistance# to measure
    EditDistance *edit;

    /// an accumulator of #EditDistance# objects, to compute statistics
    EditDistance *sum;

    ///
    EditDistanceMeasurer(EditDistance *edit_, DataSet *data_, FILE *file_);
    ///
    EditDistanceMeasurer(EditDistance *edit_, DataSet *data_, const char *filename);

    virtual void init();
    virtual void reset();
    virtual void measureEx();
    virtual void measureIter();

    virtual ~EditDistanceMeasurer();
};

#endif
