#include "ExpectationMeasurer.h"

ExpectationMeasurer::ExpectationMeasurer(SeqDataSet *data_, Distribution* distribution_,FILE *file_) : Measurer(data_, file_)
{
  distribution = distribution_;
  sdata = data_;
  expect = (real*)xalloc(sizeof(real)*sdata->n_observations);
  sdata->totNFrames();
  fprintf(file, "%d %d\n", sdata->tot_n_frames,sdata->n_observations*2);
}

ExpectationMeasurer::ExpectationMeasurer(SeqDataSet *data_, Distribution* distribution_,const char *filename) : Measurer(data_, filename)
{
  distribution = distribution_;
  sdata = data_;
  expect = (real*)xalloc(sizeof(real)*sdata->n_observations);
  sdata->totNFrames();
  fprintf(file, "%d %d\n", sdata->tot_n_frames,sdata->n_observations*2);
}

void ExpectationMeasurer::measureEx()
{
  SeqExample* ex = (SeqExample*)sdata->inputs->ptr;
  if (sdata->n_inputs>0 && sdata->n_observations>0) {
    for (int j=0;j<ex->n_frames;j++) {
      distribution->frameExpectation(expect,ex->inputs[j],j);
      real *res = expect;
      for (int k=0;k<sdata->n_observations;k++) {
        fprintf(file, "%f ", *res++);
      }
      real *obs = ex->observations[j];
      for (int k=0;k<sdata->n_observations;k++) {
        fprintf(file, "%f ", *obs++);
      }
      fprintf(file,"\n");
    }
  }
}

void ExpectationMeasurer::measureIter()
{
  fflush(file);
}

void ExpectationMeasurer::init()
{
  Measurer::init();
  reset();
}

void ExpectationMeasurer::reset()
{
}

ExpectationMeasurer::~ExpectationMeasurer()
{
  free(expect);
}

