#ifndef FRAME_NLL_MEASURER_INC
#define FRAME_NLL_MEASURER_INC

#include "NllMeasurer.h"
#include "SeqDataSet.h"

/** This class measures the negative log likelihood. In fact, it supposes
    that the input given is already the negative log likelihood. It is
    then normalized by the total number of frames.

    @author Samy Bengio (bengio@idiap.ch)
*/
class FrameNllMeasurer : public NllMeasurer
{
  public:
    ///
    FrameNllMeasurer(List *inputs_, SeqDataSet* data_, FILE *file_);
    ///
    FrameNllMeasurer(List *inputs_, SeqDataSet* data_, const char *filename);

    virtual void measureEx();
    virtual void measureIter();

    virtual ~FrameNllMeasurer();
};

#endif
