#ifndef HKMEANS_INC
#define HKMEANS_INC

#include "Trainer.h"
#include "DiagonalGMM.h"
#include "SeqDataSet.h"

/** This class is used to train a Kmeans using Hierarchicak Kmeans.
    
    @author Samy Bengio (bengio@idiap.ch)
*/
class HKmeans : public EMTrainer
{
  public:
    /// maximum number of kernels
    int max_K;

    /// maximum perturbation per dimension
    real* max_perturb;

    /// this works with any DiagonalGMM
    DiagonalGMM* gmm;

    HKmeans(DiagonalGMM *distribution_, SeqDataSet *data_, real* max_perturb_);

    virtual void train(List *measurers);

    virtual ~HKmeans();
};

#endif
