#include "IOBin.h"
#include "String.h"


IOBin::IOBin(char* data_file,char* target_file,int n_cols_,int max_load)
{
  FILE* tf=fopen(target_file,"r");
  if(tf == NULL)
    error("Cannot open file: %s\n",target_file);
  FILE* df=fopen(data_file,"r");
  if(df == NULL)
    error("Cannot open file: %s\n",data_file);

  n_cols = n_cols_;

  xfread(&n_lines,sizeof(float),1,tf);
  /* Allocate memory for aveRange source feature vectors*/

  n_lines = max_load > 0 && max_load < n_lines ? max_load : n_lines;
  int n_data = n_lines*n_cols;
  int tot_targets = n_lines;

  target = (int*)xalloc(tot_targets*sizeof(int));
  xfread(target, sizeof(int), tot_targets,tf);
  data = (real*)xalloc(n_data*sizeof(real));
  xfread(data, sizeof(float), n_data,df);
  fclose(tf);
  fclose(df);
}

IOBin::~IOBin()
{
  free(data);
  free(target);
  //free(file_name);
}


