#ifndef MAP_HMM_INC
#define MAP_HMM_INC

#include "HMM.h"

/** This class is a special case of a HMM that implements the
    MAP algorithm for HMM transitions probabilities.
    
    @author Samy Bengio (bengio@idiap.ch)
    @author Johnny Mariethoz (marietho@idiap.ch)
*/
class MAPHMM : public HMM
{
  public:
     
    /// The prior distribution used in MAP
    HMM* prior_distribution;
     
    /// The weight to give to the prior parameters during update
    real weight_on_prior;
     
    ///log(weight_on_prior)
    real log_weight_on_prior;
     
    ///log(1-weight_on_prior_
    real log_1_weight_on_prior;
    
    ///
    MAPHMM(int n_states_, Distribution **states_, real prior_transitions_,SeqDataSet* data_,real** transitions,HMM* prior_distribution_,real weight_on_prior_);

    /// map adaptation method for transitions probabilities
    virtual void eMUpdate();

    virtual ~MAPHMM();
    
};

#endif
