#include "MeanMeasurer.h"

MeanMeasurer::MeanMeasurer(void *inputs_, FILE *file_) : Measurer(NULL, file_)
{
  inputs = inputs_;
  measure = xalloc(sizeof(real)*2);

  real *r_measure = (real *)measure;
  erreur = r_measure;
  erreur_c = r_measure+1;

  *erreur = 0;

  reset();
}

MeanMeasurer::MeanMeasurer(void *inputs_, const char *filename) : Measurer(NULL, filename)
{
  inputs = inputs_;
  measure = xalloc(sizeof(real)*4);

  real *r_measure = (real *)measure;
  erreur = r_measure;
  erreur_c = r_measure+1;

  *erreur = 0;
  
  reset();
}

void MeanMeasurer::measureEx()
{
}

void MeanMeasurer::measureIter()
{
  *erreur_c += *(real*)inputs;
  n++;
  *erreur = *erreur_c / ((real)n);
}

void MeanMeasurer::measureEnd()
{
  fprintf(file, "%g\n", *erreur);
  fflush(file);
  reset();
}

void MeanMeasurer::init()
{
  Measurer::init();
  reset();
}

void MeanMeasurer::reset()
{
  *erreur_c = 0;
  n = 0;
}

MeanMeasurer::~MeanMeasurer()
{
  free(measure);
}

