#ifndef MEAN_MEASURER_INC
#define MEAN_MEASURER_INC

#include "Measurer.h"
#include "DataSet.h"

/** Mean measurer.
    Compute the mean of its inputs

    #measure# = { <[real] previous mean> <[real] current sum for computing mean> }

    @author Samy Bengio (bengio@idiap.ch)
*/
class MeanMeasurer : public Measurer
{
  public:
    real *erreur;
    real *erreur_c;
    void *inputs;
    int n;

    //-----

    ///
    MeanMeasurer(void *inputs_, FILE *file_);

    ///
    MeanMeasurer(void *inputs_, const char *filename);

    //-----

    virtual void init();
    virtual void reset();
    virtual void measureEx();
    virtual void measureIter();
    virtual void measureEnd();

    virtual ~MeanMeasurer();
};

#endif
