#ifndef MULTI_CRITERION_INC
#define MULTI_CRITERION_INC

#include "Criterion.h"

/** MultiCriterion can be used to handle multiple criterions.

    @author Samy Bengio (bengio@idiap.ch)
*/
class MultiCriterion : public Criterion
{
  public:

    /// the number of criterions
    int n_criterions;

    /// the criterions
    Criterion** criterions;

    /// the relative weight of each criterion
    real* weights;

    /// do we need to allocate the weights
    bool allocate_weights;

    //-----

    ///
    MultiCriterion(int n_criterions_,Criterion** criterions_,real* weights_ = NULL);

    //-----

    virtual void setDataSet(DataSet *data_);
    virtual void iterInitialize();
    virtual void reset();
    virtual void init();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);
    virtual ~MultiCriterion();
};

#endif
