#ifndef OUTPUT_MEASURER_INC
#define OUTPUT_MEASURER_INC

#include "Measurer.h"
#include "Machine.h"
#include "DataSet.h"

/** This class can be used to save the outputs of a #Trainer# 
    in a file in such a format that it can be read again in #Torch# using the
    #FileDataSet# class. Optionally, it also prints the corresponding inputs
    and/or the corresponding targets.

    @author Samy Bengio (bengio@idiap.ch)
*/
class OutputMeasurer : public Measurer
{
  public:
    /// the pointer the obtained outputs
    List *inputs;
    /// a boolean stating whether we also print the corresponding inputs
    bool print_inputs;
    /// a boolean stating whether we also print the corresponding targets
    bool print_targets;

    ///
    OutputMeasurer(List *inputs_, DataSet *data_, FILE *file_, bool print_inputs_=false,bool print_targets=true);
    ///
    OutputMeasurer(List *inputs_, DataSet *data_, const char *filename, bool print_inputs_=false,bool print_targets=true);

    virtual void init();
    virtual void reset();
    virtual void measureEx();
    virtual void measureIter();

    virtual ~OutputMeasurer();
};

#endif
