#ifndef PHONEME_SEQ_DATASET_INC
#define PHONEME_SEQ_DATASET_INC

#include "SeqDataSet.h"
#include "Dictionary.h"
#include "HMM.h"

/** This class is designed to create a dataset based on another
    dataset using parts only related to a given phoneme
   
    @author Samy Bengio (bengio@idiap.ch)
 */
class PhonemeSeqDataSet : public SeqDataSet
{
  public :

    /// create a new Phoneme dataset from generic SeqDataSet
    /// if alignment is not existant, then use models and do a linear alignment
    PhonemeSeqDataSet(SeqDataSet* data,int phoneme, Dictionary* dict, HMM** models=NULL);
    
    virtual void addExample(SeqExample* ex, int start, int end);

    virtual void freeMemory();

    virtual ~PhonemeSeqDataSet();
};

#endif     
