#ifndef REG_TREE_INC
#define REG_TREE_INC

#include "MLLRDiagonalGMM.h"
#include "SeqDataSet.h"

class RegTree
{
   public:
      MLLRDiagonalGMM* gmm;
      real* left_center;
      real* right_center;
      real* sigma;
      real* delta;
      real perturb;
      int* gauss_list;
      int n_gauss;
      int n_obs_per_gauss;
      int* gauss_n_obs;
      int n_matrix_shared;

      RegTree(MLLRDiagonalGMM* gmm_,int n_obs_per_gauss);
      int buildRegTree();
      void buildTree();
      int computeNObs(int* g,int n);
      void computeMeanSigma();
      void computeMean(int* g_index,int n_val,real* means);
      void linkNode();
      void computeDelta();
      void perturbCenter();
      real computeDist(real* means,real* observations);
      void distribute(int* right_gauss_list,int& n_right_gauss,int* left_gauss_list,int& n_left_gauss);
      ~RegTree();
};
#endif
