#ifndef SIGM_MLP_INC
#define SIGM_MLP_INC

#include "ConnectedMachine.h"
#include "Linear.h"
#include "Tanh.h"
#include "SumMachine.h"
#include "Sigmoid.h"

class SigmMLP : public ConnectedMachine
{
  public:
    Linear *hidden_layer;
    Tanh *hidden_tanh_layer;
    Linear *outputs_layer;
    Sigmoid *outputs_sigm_layer;
    int n_hidden;
    int is_linear_outputs;
    Linear* add_layer;
    SumMachine* sum_layer;

    SigmMLP(int n_inputs_, int n_hidden, int n_outputs_, bool is_linear_outputs_=true,bool inputs_to_outputs=false);
    virtual ~SigmMLP();
};

#endif
