#include "Sin.h"

Sin::Sin(int n_units)
{
  n_inputs = n_units;
  n_outputs = n_units;
}

int Sin::numberOfParams()
{
  return(0);
}

void Sin::forward(List *inputs)
{
  real *ptr_out = (real *)outputs->ptr;
  while(inputs)
  {
    real *x = (real *)inputs->ptr;
    for(int j = 0; j < inputs->n; j++)
      *ptr_out++ = sin(*x++);
    inputs = inputs->next;
  }
}

void Sin::backward(List *inputs, real *alpha)
{
  real *alpha_ptr = alpha;
  real *beta_ptr = beta;
  while(inputs)
  {
    real *x = (real *)inputs->ptr;
    for(int j = 0; j < inputs->n; j++)
      *beta_ptr++ = *alpha_ptr++ * cos(*x++);
    inputs = inputs->next;
  }
}

Sin::~Sin()
{
}
