#include "ThresholdTwoClassFormat.h"

ThresholdTwoClassFormat::ThresholdTwoClassFormat(DataSet *data, real threshold_) : TwoClassFormat(data)
{
  threshold = threshold_;
}

ThresholdTwoClassFormat::ThresholdTwoClassFormat(real class_1, real class_2, real threshold_) : TwoClassFormat(class_1,class_2)
{
  threshold = threshold_;
}

int ThresholdTwoClassFormat::getOutputClass(List *outputs)
{
  real out = *((real *)outputs->ptr);
  int maxclass = (tabclasses[1]>tabclasses[0]);
  int minclass = (tabclasses[0]>tabclasses[1]);
  
  return (out > threshold ? maxclass : minclass);
}

void ThresholdTwoClassFormat::setThreshold(real threshold_)
{
  threshold = threshold_;
}

ThresholdTwoClassFormat::~ThresholdTwoClassFormat()
{
}
