
#include "TransposeSeqDataSet.h"
#include "String.h"
#ifdef USEDOUBLE
#define REAL_FORMAT "%lf"
#else
#define REAL_FORMAT "%f"
#endif

TransposeSeqDataSet::TransposeSeqDataSet(SeqDataSet* data,int n_observations_)
{
    n_examples = data->tot_n_frames;
    n_real_examples = 0;
    n_file_names = 0;
    file_names = NULL;
    examples = (SeqExample*) xalloc(sizeof(SeqExample)*n_examples);
    n_observations = n_observations_;
   int n_f = data->n_observations/n_observations; 
    //create new SeqDataSet with transpose datas
    for(int j=0;j<data->n_examples;j++){
        data->setExample(j);
        for(int k=0;k<data->n_frames;k++){
           data->setFrame(k);
           
           SeqExample* internal_example = &examples[n_real_examples];
           internal_example->n_real_frames = n_f;
           internal_example->n_frames = n_f;
           internal_example->n_seqtargets = 0;
           internal_example->seqtargets = NULL;
           internal_example->name = NULL;
           internal_example->selected_frames = NULL;
           internal_example->current_frame = 0;
           SeqExample* ex = (SeqExample*)data->inputs->ptr;
           internal_example->observations = (real**)xalloc(sizeof(real*)*internal_example->n_frames);
           if(data->n_inputs > 0){
              internal_example->inputs = (real**)xalloc(sizeof(real*)*internal_example->n_frames);
              transpose(internal_example,ex->observations[ex->selected_frames[k]],data->n_observations,ex->inputs[ex->selected_frames[k]],data->n_inputs);
           }
           else{
              internal_example->inputs = NULL;
              transpose(internal_example,ex->observations[ex->selected_frames[k]],data->n_observations,NULL,0);
           }
           n_real_examples++;
        }
    }
    
}

void TransposeSeqDataSet::transpose(SeqExample* ex,real* observations, int n_obs, real* the_inputs,int n_in){
   real** ex_obs = ex->observations;
   real* obs = observations;
   int new_n_observations = n_obs / ex->n_frames;
   int new_n_inputs = n_in / ex->n_frames;

   for(int i=0;i<ex->n_frames;i++,ex_obs++,obs+=new_n_observations)
      *ex_obs = obs;
   if(ex->inputs){
      real** ex_in = ex->inputs;
      real* in = the_inputs;
      for(int i=0;i<ex->n_frames;i++,ex_in++,in+=new_n_inputs)
         *ex_in = in;
   }
}


TransposeSeqDataSet::~TransposeSeqDataSet()
{
  freeMemory();
}


void TransposeSeqDataSet::freeMemory()
{
  
  for(int example = 0; example < n_real_examples; example++)
  {
      for (int i=0;i<examples[example].n_seqtargets;i++)
        free(examples[example].seqtargets[i]);
   //   for(int frame = 0; frame < n_frames; frame++) {
   //     if(n_inputs > 0) 
   //       free(examples[example].inputs[frame]);
        
  //      if(n_observations > 0) 
  //        free(examples[example].observations[frame]);
   // }
  
    if (examples[example].inputs) {
      free(examples[example].inputs);
      examples[example].inputs = NULL;
    }
    if (examples[example].observations) {
      free(examples[example].observations);
      examples[example].observations = NULL;
    }
    
    if(examples[example].selected_frames) {
      free(examples[example].selected_frames);
      examples[example].selected_frames = NULL;
    }
  }
  
  free(examples);
  for (int i = 0;i<n_file_names;i++){
     if(file_names[i] != NULL){
        free(file_names[i]);
        file_names[i] = NULL;
     }
  }
  free(file_names);
}
