#ifndef TRANSPOSE_SEQ_DATASET_INC
#define TRANSPOSE_SEQ_DATASET_INC

#include "SeqDataSet.h"
#include "StdDataSet.h"


/** This class is designed to transpose a dataset typically
    to initialize HMM2
   
    @author Johnny Mariethoz (Johnny.Mariethoz@idiap.ch)
    @author Samy Bengio (bengio@idiap.ch)
 */
class TransposeSeqDataSet : public SeqDataSet
{
  public :

    /// create a new Transpose dataset from generic SeqDataSet
    TransposeSeqDataSet( SeqDataSet* data,int n_observations_);
    
    /// method to transpose an observation
    void transpose(SeqExample* ex,real* observations, int n_obs, real* the_inputs,int n_in);

    virtual void freeMemory();

    virtual ~TransposeSeqDataSet();
};

#endif     
