// Ce mesureur calcule le *proportion d'erreur*
// de classification des <inputs> par rapport
// au <targets> de <data>.
//
// Ce measurer ne gere que deux classes:
// seule la premiere valeur de <inputs> est
// utilisee.
//
// Le code cherche lui-meme dans les
// targets de tout les exemples de train
// la valeur des targets des deux classes...
//
// ...il peut donc poser probleme si vous
// voulez l'utiliser en test et que vous
// n'avez qu'une classe dans ce subset.
//
// <measure> = {<[real] error proportion>, <[real] current number of errors>}
//

#ifndef TWO_CLASS_BOOSTING_MEASURER_INC
#define TWO_CLASS_BOOSTING_MEASURER_INC

#include "Machine.h"
#include "BoostingMeasurer.h"
#include "DataSet.h"

class TwoClassBoostingMeasurer : public BoostingMeasurer
{
  public:
    real tabclasses[2];
    real *erreur;
    real *erreur_c;
    int current_example;

    //-----

    TwoClassBoostingMeasurer(FILE *file_);
    TwoClassBoostingMeasurer(const char *filename);
    virtual void setData(DataSet *data_);

    //-----

    virtual void reset();
    virtual void measureEx();
    virtual void measureIter();

    virtual ~TwoClassBoostingMeasurer();
};

#endif
