#ifndef VECTOR_MEASURER_INC
#define VECTOR_MEASURER_INC

#include "Measurer.h"
#include "Machine.h"
#include "DataSet.h"

/** This simple measurer can be used to print out the value of a given
    vector after each iteration.

    @author Samy Bengio (bengio@idiap.ch)
*/
class VectorMeasurer : public Measurer
{
  public:
    /// the pointer to the vector to measure
    real *inputs;
    /// the size of the vector to measure
    int n_inputs;

    ///
    VectorMeasurer(real *inputs_, int n_inputs_, DataSet *data_, FILE *file_);
    ///
    VectorMeasurer(real *inputs_, int n_inputs_, DataSet *data_, const char *filename);

    virtual void init();
    virtual void reset();
    virtual void measureIter();

    virtual ~VectorMeasurer();
};

#endif
