#ifndef VITERBI_TRAINER_INC
#define VITERBI_TRAINER_INC

#include "EMTrainer.h"

/** This class is used to train any distribution using the Viterbi algorithm.
    This means that it is most useful for distributions over sequences,
    such as HMMs.
     
    @author Samy Bengio (bengio@idiap.ch)
*/

class ViterbiTrainer : public EMTrainer
{
  public:
    
    ///
    ViterbiTrainer(Distribution *distribution_, SeqDataSet *data_);

    virtual void train(List *measurers);
    virtual void test(List *measurers);

    virtual ~ViterbiTrainer();
};

#endif
