#ifndef WIN_LAYER_INC
#define WIN_LAYER_INC

#include "GradientMachine.h"
#include "SigmMLP.h"
#include "Linear.h"

class WinLayer : public GradientMachine
{
  public:
    Linear *lin_layer;
    SigmMLP *mlp;
    real *alpha_mlp;

    WinLayer(int n_inputs_, int n_outputs_, int n_hu_gater);

    virtual void init();
    virtual int numberOfParams();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);
    virtual void allocateMemory();
    virtual void freeMemory();

    //-----

    virtual void reset();
    virtual void loadFILE(FILE *file);
    virtual void saveFILE(FILE *file);
    virtual ~WinLayer();
};

#endif
