
#include "ImageSeqDataSet.h"
#include "String.h"

ImageSeqDataSet::ImageSeqDataSet(real* data, int n_data)
{
  n_file_names = 0;
  n_real_examples = n_data;
  examples = (SeqExample*)xalloc(n_real_examples * sizeof(SeqExample));
  n_observations = 1;
  n_inputs = 0;
  n_targets = 0;

  for(int example = 0; example < n_real_examples; example++) {
    examples[example].n_frames = 1;
    examples[example].n_real_frames = 1;
    examples[example].n_seqtargets = 0;
    examples[example].seqtargets = NULL;
    examples[example].selected_frames = NULL;
    examples[example].name = NULL;
    examples[example].n_alignments = 0;
    examples[example].alignment = NULL;
    examples[example].alignment_phoneme = NULL;
    examples[example].inputs = NULL;

    examples[example].observations = (real**) xalloc(sizeof(real*));
    examples[example].observations[0] = &data[example];
  }
  file_names = NULL;
}


ImageSeqDataSet::~ImageSeqDataSet()
{
  freeMemory();
}

void ImageSeqDataSet::freeMemory()
{
  
  for(int example = 0;example < n_real_examples;example++) {
    free(examples[example].observations);
    examples[example].observations = NULL;
    
    if(examples[example].selected_frames) {
      free(examples[example].selected_frames);
      examples[example].selected_frames = NULL;
    }
  }
  
  free(examples);
  for (int i = 0;i<n_file_names;i++){
    if(file_names[i] != NULL){
      free(file_names[i]);
      file_names[i] = NULL;
    }
  }
  free(file_names);
}
