// nll criterion.
// simply returns the negative log likelihood

#ifndef NLL_CRITERION_INC
#define NLL_CRITERION_INC

#include "Criterion.h"
#include "SeqDataSet.h"

/** This criterion can be used to train #Distribution# object using
    the #GMTrainer# trainer. It then maximizes the log likelihood of the
    data.

    The #forward# method always return its input, which is the negative log
    likelihood, while the #backward# method sets the gradient to -1.

    @author Samy Bengio (bengio@idiap.ch)
*/
class NllCriterion : public Criterion
{
  public:

    ///
    NllCriterion();

    virtual void reset();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);
    virtual ~NllCriterion();
};

#endif
