#include "NllMeasurer.h"

NllMeasurer::NllMeasurer(List *inputs_, SeqDataSet *data_, FILE *file_) : Measurer(data_, file_)
{
  inputs = inputs_;
  sdata = data_;
  measure = xalloc(sizeof(real)*2);

  real *r_measure = (real *)measure;
  erreur = r_measure;
  erreur_c = r_measure+1;

  *erreur = 0;
  tot_n_frames = 0;

  reset();
}

NllMeasurer::NllMeasurer(List *inputs_, SeqDataSet *data_, const char *filename) : Measurer(data_, filename)
{
  inputs = inputs_;
  sdata = data_;
  measure = xalloc(sizeof(real)*2);

  real *r_measure = (real *)measure;
  erreur = r_measure;
  erreur_c = r_measure+1;

  *erreur = 0;
  tot_n_frames = 0;
  
  reset();
}

void NllMeasurer::measureEx()
{
  *erreur_c += *(real*)inputs->ptr;
  tot_n_frames += sdata->n_frames;
}

void NllMeasurer::measureIter()
{
  *erreur = *erreur_c / ((real)tot_n_frames);

  fprintf(file, "%g\n", *erreur);
  fflush(file);
  reset();
}

void NllMeasurer::init()
{
  Measurer::init();
  reset();
}

void NllMeasurer::reset()
{
  *erreur_c = 0;
  tot_n_frames = 0;
}

NllMeasurer::~NllMeasurer()
{
  if(measure){
   free(measure);
   measure = NULL;
  }
}

