
#include "log_add.h"
#include "general.h"


real log_add(real log_a, real log_b)
{
  if (log_a < log_b) {
    real tmp = log_a;
    log_a = log_b;
    log_b = tmp;
  }

  real minusdif = log_b - log_a;
  if (isnan(minusdif))
    error("minusdif (%f) log_b (%f) or log_a (%f) is nan",minusdif,log_b,log_a);

  if (minusdif < MINUS_LOG_THRESHOLD)
    return log_a;
  else
    return log_a + log1p(exp(minusdif));
}

real log_sub(real log_a, real log_b)
{
  if (log_a < log_b)
    error("log_sub: log_a (%f) should be greater than log_b (%f)", log_a, log_b);

  real minusdif = log_b - log_a;
  if (isnan(minusdif))
    error("minusdif (%f) log_b (%f) or log_a (%f) is nan",minusdif,log_b,log_a);

  if (log_a == log_b)
    return LOG_ZERO;
  else if (minusdif < MINUS_LOG_THRESHOLD)
    return log_a;
  else
    return log_a + log1p(-exp(minusdif));
}

