#ifndef LOG_ADD_H
#define LOG_ADD_H

#include "general.h"

/** Some simple functions for log operations.

    @author Samy Bengio (bengio@idiap.ch)
*/
//@{
#define LOG_2_PI 1.83787706640934548355
//#define LOG_ZERO -INF
#define LOG_ZERO -1e10
#define LOG_ONE 0

#define MINUS_LOG_THRESHOLD -18.42

/** log_add(log_a,log_b) = log(a+b) = log(exp(log_a)+exp(log_b))
    but done in a smart way so that if log_a or log_b are large
    but not their difference the computation works correctly.
*/
real log_add(real log_a,real log_b);

/// log_sub(log_a,log_b) = log(a-b)
real log_sub(real log_a,real log_b);
//@}
#endif

