#ifndef CRITERION_INC
#define CRITERION_INC

#include "GradientMachine.h"
#include "DataSet.h"

/** #Criterion# class for #GMTrainer#.
    A #Criterion# computes an error with its inputs
    and a dataset #data#.

    It knows how to backpropagate this error.

    A #Criterion# shouldn't be connected to the inputs of
    another #GradientMachine#.
    ne doit pas se connecter sur l'entree d'une

    By default, the number of outputs for a #Criterion#
    is fixed to one. It \emph{must} contain the error:
    This one is used by the #GMTrainer# for the
    stopping criterion.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class Criterion : public GradientMachine
{
  public:

    /// #DataSet# used to compute the error.
    DataSet *data;

    ///
    Criterion();

    /** Set #data# to #data_#. The criterion
        should be able to react to this function.
    */
    virtual void setDataSet(DataSet *data_);

    //-----

    virtual int numberOfParams();
    virtual ~Criterion();
};

#endif
