#ifndef EUCLIDEAN_DATA_SET_INC
#define EUCLIDEAN_DATA_SET_INC

#include "DataSet.h"

/** #DataSet# with dot-products.

    @author Ronan Collobert (collober@iro.umontreal.ca)
 */
class EuclideanDataSet : public DataSet
{
  public:

    ///
    EuclideanDataSet();

    /// Dot product functions
    /** Dot products between two examples. Not that
        if a parameter is a #List#, this one \emph{must} have
        the same format as the format generated by the #DataSet#
        class for #inputs#.
    */
    /// Between #selected_examples[i]# and #selected_examples[j]#.
    real dotProduct(int i, int j);

    /// Between #selected_examples[i]# and #y#.
    real dotProduct(int i, List *y);

    /// Between #i# and #selected_examples[j]#
    real realDotProduct(int i, int j);

    /// Between #i# and #j#
    virtual real realRealDotProduct(int i, int j) = 0;

    /// Between #i# and #y#
    virtual real realDotProduct(int i, List *y) = 0;

    /// Between #x# and #y#
    virtual real dotProduct(List *x, List *y) = 0;

    virtual ~EuclideanDataSet();
};

#endif
