#ifndef FILE_SPARSE_DATA_SET_INC
#define FILE_SPARSE_DATA_SET_INC

#include "SparseDataSet.h"
#include "IOTorch.h"

/** Create a #DataSet# from a \emph{sparse} disk file.

    @author Ronan Collobert (collober@iro.umontreal.ca)
 */
class FileSparseDataSet : public SparseDataSet
{
  public:
    IOTorch melanie;

    //-----

    /** Load #file# in memory.
        \begin{itemize}
          \item #n_inputs_# is the input dimension of each example.
          \item #n_targets# is the target dimension of each example.
          \item #bin# is #true# if the file is in binary format.
          \item if #max_load# > 0, it loads only the first #max_load# examples.
        \end{itemize}
    */
    FileSparseDataSet(const char *file, int n_inputs_, int n_targets, bool bin=false, int max_load=-1);

    //-----

    virtual ~FileSparseDataSet();
};

#endif

