#ifndef GMTRAINER_INC
#define GMTRAINER_INC

#include "Trainer.h"
#include "GradientMachine.h"
#include "DataSet.h"
#include "Criterion.h"
#include "Optimizer.h"

/** Trainer for GradientMachine.

    @author Ronan Collobert (collober@iro.umontreal.ca)
 */
class GMTrainer : public Trainer
{
  public:
    GradientMachine *g_machine;
    Criterion *criterion;
    Optimizer *optimizer;

    //-----

    /** Take the #machine_# to train, the train #data_#, the #criterion_#
        to use, and the #optimizer_# to use.
    */
    GMTrainer(GradientMachine *machine_, DataSet *data_, Criterion *criterion_, Optimizer *optimizer_);

    //-----

    virtual void train(List *measurers);
    virtual ~GMTrainer();
};

#endif
