#ifndef INPUTS_SELECT_INC
#define INPUTS_SELECT_INC

#include "GradientMachine.h"

/** Machine which select a block of adjacent
    inputs, and put them in the outputs.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class InputsSelect : public GradientMachine
{
  public:
    int offset;

    //-----

    /** Select #n_selected_# inputs from #offset_#.
        (The input #offset_# will be included).
    */
    InputsSelect(int n_inputs_, int offset_, int n_selected_);

    //-----

    virtual void init();
    virtual int numberOfParams();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);
    virtual ~InputsSelect();
};

#endif
