#ifndef MSE_CRITERION_INC
#define MSE_CRITERION_INC

#include "Criterion.h"

/** Mean Squared Error criterion.
    Compute the MSE between its inputs and,
    the targets of its associated #DataSet#.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class MseCriterion : public Criterion
{
  public:

    //-----

    ///
    MseCriterion(int n_inputs_);

    //-----

    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);
    virtual ~MseCriterion();
};

#endif
