#ifndef MULTI_CLASS_FORMAT_INC
#define MULTI_CLASS_FORMAT_INC

#include "ClassFormat.h"
#include "DataSet.h"

/** Define the multi class code.
    Each class is coded by a single number.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class MultiClassFormat : public ClassFormat
{
  public:

    /// Table of class labels
    real *tabclasses;

    /// Autodetect classes
    MultiClassFormat(DataSet *data);

    /// By default, class labels are 0, 1, ...
    MultiClassFormat(int n_classes_, real *class_labels_=NULL);

    virtual int getTargetClass(void *target);
    virtual int getOutputClass(List *outputs);

    virtual int getOutputSize();
    virtual void fromOneHot(List *outputs, List *one_hot_outputs);
    virtual void toOneHot(List *outputs, List *one_hot_outputs);

    virtual ~MultiClassFormat();
};

#endif
