#ifndef NPTRAINER_INC
#define NPTRAINER_INC

#include "Trainer.h"

/** Trainer for Non Parametric Machines. This trainer does nothing during
    training! But it can be used to test Non Parametric models such as
    KNN or ParzenDistributions or even select a correct hyper-parameter
    using cross-validation.

    @author Samy Bengio (bengio@idiap.ch)
 */
class NPTrainer : public Trainer
{
  public:

    NPTrainer(Machine *machine_, DataSet *data_);

    //-----

    virtual void train(List *measurers);
    virtual ~NPTrainer();
};

#endif
