#ifndef ONE_HOT_CLASS_FORMAT_INC
#define ONE_HOT_CLASS_FORMAT_INC

#include "ClassFormat.h"
#include "DataSet.h"

/** Define the one hot class code.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class OneHotClassFormat : public ClassFormat
{
  public:
    real *class_labels_buffer;

    /// Autodetect
    OneHotClassFormat(DataSet *data);

    /// What's the number of classes ?
    OneHotClassFormat(int n_targets);

    virtual int getTargetClass(void *target);
    virtual int getOutputClass(List *outputs);

    virtual int getOutputSize();
    virtual void fromOneHot(List *outputs, List *one_hot_outputs);
    virtual void toOneHot(List *outputs, List *one_hot_outputs);

    virtual ~OneHotClassFormat();
};

#endif
