#ifndef TANH_INC
#define TANH_INC

#include "GradientMachine.h"

/** Tanh layer for #GradientMachine#.

    The number of inputs/outputs is the number
    of units for this machine.
    Formally speaking, $ouputs[i] = tanh(inputs[i])$.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class Tanh : public GradientMachine
{
  public:

    /// Create a layer of size #n_units#
    Tanh(int n_units);

    //-----

    virtual int numberOfParams();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);

    virtual ~Tanh();
};

#endif
