#ifndef TWO_CLASS_FORMAT_INC
#define TWO_CLASS_FORMAT_INC

#include "ClassFormat.h"
#include "DataSet.h"

/** Define the two class code.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class TwoClassFormat : public ClassFormat
{
  public:
    real tabclasses[2];

    /// Autodetect classes
    TwoClassFormat(DataSet *data);

    /// Give the label of the classes
    TwoClassFormat(real class_1, real class_2);

    virtual int getTargetClass(void *target);
    virtual int getOutputClass(List *outputs);

    virtual int getOutputSize();
    virtual void fromOneHot(List *outputs, List *one_hot_outputs);
    virtual void toOneHot(List *outputs, List *one_hot_outputs);

    virtual ~TwoClassFormat();
};

#endif
