#ifndef CLASS_FORMAT_INC
#define CLASS_FORMAT_INC

#include "Object.h"
#include "List.h"

/** Used to define a class code.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class ClassFormat : public Object
{
  public:

    /// Number of classes that the object currently handles
    int n_classes;
    /// The label of each class
    real **class_labels;
    
    ///
    ClassFormat();

    /// Returns #n_classes#
    int getNumberOfClasses();

    /// Returns the output size;
    virtual int getOutputSize() = 0;

    /// Transforms the output from a OneHot representation
    virtual void fromOneHot(List *outputs, List *one_hot_outputs) = 0;

    /// Transforms the output to a OneHot representation
    virtual void toOneHot(List *outputs, List *one_hot_outputs) = 0;

    /// Returns the class of #target#
    virtual int getTargetClass(void *target) = 0;

    /// Returns the class of #outputs#
    virtual int getOutputClass(List *outputs) = 0;

    virtual ~ClassFormat();
};

#endif
