#include "Exp.h"

Exp::Exp(int n_units)
{
  n_outputs = n_units;
  n_inputs = n_units;
}

int Exp::numberOfParams()
{
  return(0);
}

void Exp::forward(List *inputs)
{
  real *ptr_out = (real *)outputs->ptr;
  while(inputs)
  {
    real *x = (real *)inputs->ptr;
    for(int j = 0; j < inputs->n; j++)
      *ptr_out++ = exp(*x++);
    inputs = inputs->next;
  }
}

void Exp::backward(List *inputs, real *alpha)
{
  real *alpha_ptr = alpha;
  real *beta_ptr = beta;
  real *out_ptr = (real *)outputs->ptr;
  for(int i = 0; i < n_outputs; i++)
  {
    real z = *out_ptr++;
    *beta_ptr++ = *alpha_ptr++ * z;
  }
}

Exp::~Exp()
{
}
