#ifndef EXP_INC
#define EXP_INC

#include "GradientMachine.h"

/** Exponentiel layer for #GradientMachine#.

    The number of inputs/outputs is the number
    of units for this machine.
    Formally speaking, $ouputs[i] = exp(inputs[i])$.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class Exp : public GradientMachine
{
  public:

    /// Create a layer of size #n_units#
    Exp(int n_units);

    //-----

    virtual int numberOfParams();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);

    virtual ~Exp();
};

#endif
