#include "GradientMachine.h"

GradientMachine::GradientMachine()
{
  is_free = false;
  n_params = 0;
  params = NULL;
  der_params = NULL;

  beta = NULL;
}

void GradientMachine::allocateMemory()
{
  n_params = numberOfParams();

  if(n_params > 0)
  {
    addToList(&params, n_params, (real *)xalloc(sizeof(real)*n_params));
    addToList(&der_params, n_params, (real *)xalloc(sizeof(real)*n_params));
  }

  beta = (real *)xalloc(sizeof(real)*n_inputs);
  addToList(&outputs, n_outputs, (real *)xalloc(sizeof(real)*n_outputs));
}

void GradientMachine::freeMemory()
{
  if(is_free)
    return;

  if(n_params > 0)
  {
    freeList(&params, true);
    freeList(&der_params, true);
  }

  free(beta);
  freeList(&outputs, true);
  is_free = true;
}

void GradientMachine::init()
{
  allocateMemory();
}

void GradientMachine::iterInitialize()
{
}

void GradientMachine::reset()
{
}

void GradientMachine::loadFILE(FILE *file)
{
  List *liste = params;

  while(liste)
  {
    xfread(liste->ptr, sizeof(real), liste->n, file);
    liste = liste->next;
  }
}

void GradientMachine::saveFILE(FILE *file)
{
  List *liste = params;

  while(liste)
  {
    xfwrite(liste->ptr, sizeof(real), liste->n, file);
    liste = liste->next;
  }
}

GradientMachine::~GradientMachine()
{
  freeMemory();
}
