#include "InputsSelect.h"

InputsSelect::InputsSelect(int n_inputs_, int offset_, int n_selected_)
{
  n_inputs = n_inputs_;
  offset = offset_;
  n_outputs = n_selected_;
}

int InputsSelect::numberOfParams()
{
  return(0);
}

void InputsSelect::init()
{
  GradientMachine::init();

  for(int i = 0; i < offset; i++)
    beta[i]  = 0;

  for(int i = offset+n_outputs; i < n_inputs; i++)
    beta[i]  = 0;
}

void InputsSelect::forward(List *inputs)
{
  real *ptr_out = (real *)outputs->ptr;
  int k = 0;
  while(inputs)
  {
    if(k+inputs->n < offset)
      k += inputs->n;
    else
    {
      real *x = (real *)inputs->ptr;
      for(int i = 0; i < inputs->n; i++)
      {
        if(k >= offset)
        {
          *ptr_out++ = *x;
          if(k >= offset+n_outputs-1)
            break;
        }
        x++;
        k++;
      }
    }

    if(k >= offset+n_outputs)
      break;

    inputs = inputs->next;
  }
}

void InputsSelect::backward(List *inputs, real *alpha)
{
  real *ptr_beta = beta + offset;
  for(int i = 0; i < n_outputs; i++)
    *ptr_beta++ = *alpha++;
}

InputsSelect::~InputsSelect()
{
}
