#include "List.h"
#include "general.h"

void addToList(List **x_, List *y)
{
  List *x = *x_;
  bool astrid = true;

  if(!y)
    return;

  if(!x)
  {
    x = (List *)xalloc(sizeof(List));
    x->next = NULL;
    *x_ = x;
    astrid = false;
  }
  else
  {
    while(x->next)
      x = x->next;
  }

  while(y)
  {
    if(astrid)
    {
      x->next = (List *)xalloc(sizeof(List));
      x = x->next;
    }
    else
      astrid = true;

    x->n = y->n;
    x->ptr = y->ptr;
    x->next = NULL;
    y = y->next;
  }
}

void addToList(List **x_, int n, void *ptr)
{
  List *x = *x_;
  bool astrid = true;

  if(!x)
  {
    x = (List *)xalloc(sizeof(List));
    x->next = NULL;
    *x_ = x;
    astrid = false;
  }
  else
  {
    while(x->next)
      x = x->next;
  }

  if(astrid)
  {
    x->next = (List *)xalloc(sizeof(List));
    x = x->next;
  }
  
  x->n = n;
  x->ptr = ptr;
  x->next = NULL;
}

void freeList(List **x_, bool free_ptrs)
{
  List *x = *x_;
  List *y;

  while(x)
  {
    y = x->next;
    if(free_ptrs)
      free(x->ptr);
    free(x);
    x = y;
  }

  *x_ = NULL;
}

void copyList(List* to, List* from)
{
  real* from_ptr = (real*)from->ptr;
  int index_from = 0;

  while(to)
  { 
    real* to_ptr = (real*)to->ptr;
    for(int i = 0; i < to->n; i++)
    {
      if(index_from == from->n)
      {
        from = from->next;
        from_ptr = (real*)from->ptr;
        index_from = 0;
      }
      *to_ptr++ = *from_ptr++;
      index_from++;
    }
    to = to->next;
  }
}

void copyList(real* to, List* from)
{
  while(from)
  {
    real* from_ptr = (real*)from->ptr;
    for(int i = 0; i < from->n; i++)
      *to++ = *from_ptr++;
    from = from->next;
  }
}
