#include "MseCriterion.h"

MseCriterion::MseCriterion(int n_inputs_)
{
  n_inputs = n_inputs_;
}


void MseCriterion::forward(List *inputs)
{
  real *desired = (real *)data->targets;
  real err = 0;
  while(inputs)
  {
    real *x = (real *)inputs->ptr;
    for(int j = 0; j < inputs->n; j++)
    {
      real z = *desired++ - *x++;
      err += z*z;
    }
    inputs = inputs->next;
  }

  real *ptr_out = (real *)outputs->ptr;
  ptr_out[0] = err;
}

void MseCriterion::backward(List *inputs, real *alpha)
{
  real *desired = (real *)data->targets;
  real *ptr_beta = beta;
  while(inputs)
  {
    real *x = (real *)inputs->ptr;
    for(int j = 0; j < inputs->n; j++)
      *ptr_beta++ = 2.*(*x++ - *desired++);
    inputs = inputs->next;
  }
}

MseCriterion::~MseCriterion()
{
}
