#include "MseMeasurer.h"

MseMeasurer::MseMeasurer(List *inputs_, DataSet *data_, FILE *file_) : Measurer(data_, file_)
{
  inputs = inputs_;
  measure = xalloc(sizeof(real)*2);

  real *r_measure = (real *)measure;
  erreur = r_measure;
  erreur_c = r_measure+1;

  *erreur = 0;

  reset();
}

MseMeasurer::MseMeasurer(List *inputs_, DataSet *data_, const char *filename) : Measurer(data_, filename)
{
  inputs = inputs_;
  measure = xalloc(sizeof(real)*4);

  real *r_measure = (real *)measure;
  erreur = r_measure;
  erreur_c = r_measure+1;

  *erreur = 0;
  
  reset();
}

void MseMeasurer::measureEx()
{
  real *des = (real *)data->targets;

  List *inputs_ = inputs;
  while(inputs_)
  {
    real *out = (real *)inputs_->ptr;
    for(int i = 0; i < inputs_->n; i++)
    {
      real z = *out++ - *des++;
      *erreur_c += z*z;
    }
    inputs_ = inputs_->next;
  }
}

void MseMeasurer::measureIter()
{
  *erreur = *erreur_c / ((real)data->n_examples);

  fprintf(file, "%g\n", *erreur);
  fflush(file);
  reset();
}

void MseMeasurer::init()
{
  Measurer::init();
  reset();
}

void MseMeasurer::reset()
{
  *erreur_c = 0;
}

MseMeasurer::~MseMeasurer()
{
  free(measure);
}

