#ifndef MSE_MEASURER_INC
#define MSE_MEASURER_INC

#include "Measurer.h"
#include "DataSet.h"

/** Mean Squared Error measurer.
    Compute the MSE between its inputs,
    and the targets of its associated #DataSet#.

    #measure# = { <[real] previous MSE> <[real] current sum for computing MSE> }

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class MseMeasurer : public Measurer
{
  public:
    real *erreur;
    real *erreur_c;
    List *inputs;

    //-----

    ///
    MseMeasurer(List *inputs_, DataSet *data_, FILE *file_);

    ///
    MseMeasurer(List *inputs_, DataSet *data_, const char *filename);

    //-----

    virtual void init();
    virtual void reset();
    virtual void measureEx();
    virtual void measureIter();

    virtual ~MseMeasurer();
};

#endif
