#include "Object.h"

Object::Object()
{
  n_options = 0;
  options = NULL;
}

void Object::addOption(const char *name, int size, void *ptr, void *initvalue, const char *help)
{
  options = (Option *)xrealloc((void *)options, (n_options+1)*sizeof(Option));

  Option *optr = options+n_options;

  optr->name = (char *)malloc(strlen(name)+1);
  optr->help = (char *)malloc(strlen(help)+1);
  strcpy(optr->name, name);
  strcpy(optr->help, help);
  optr->size = size;
  optr->ptr = ptr;

  n_options++;

  if(initvalue)
    setOption(name, initvalue);
}

void Object::setOption(const char *name, void *ptr)
{
  Option *optr = options;

  bool flag = false;
  for(int i = 0; i < n_options; i++, optr++)
  {
    if( !strcmp(optr->name, name) )
    {
      flag = true;
      break;
    }
  }

  if(!flag)
    error("Object: option doesn't exists: %s", name);

  char *odata = (char *)optr->ptr;
  char *odatao = (char *)ptr;

  for(int i = 0; i < optr->size; i++)
  {
    *odata = *odatao;
    odata++;
    odatao++;
  }
}

void Object::setIOption(const char *name, int option)
{
  setOption(name, (void *)&option);
}

void Object::setROption(const char *name, real option)
{
  setOption(name, (void *)&option);
}

void Object::setBOption(const char *name, bool option)
{
  setOption(name, (void *)&option);
}

void Object::load(const char *filename)
{
  FILE *file;

  if( (file = fopen(filename, "r")) == NULL)
    error("Object: cannot open the file <%s>", filename);

  loadFILE(file);

  fclose(file);
}

void Object::save(const char *filename)
{
  FILE *file;

  if( (file = fopen(filename, "w")) == NULL)
    error("Object: cannot open the file <%s>", filename);

  saveFILE(file);

  fclose(file);
}

void Object::loadFILE(FILE *file)
{
}

void Object::saveFILE(FILE *file)
{
}

Object::~Object()
{
  for(int i = 0; i < n_options; i++)
  {
    free(options[i].name);
    free(options[i].help);
  }
  free(options);
}
