#ifndef SIGMOID_INC
#define SIGMOID_INC

#include "GradientMachine.h"

/** Sigmoid layer for #GradientMachine#.

    The number of inputs/outputs is the number
    of units in the machine.

    Formally speaking, $ouputs[i] = 1/(1+ exp(-inputs[i]))$

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
class Sigmoid : public GradientMachine
{
  public:

    //-----

    /// Create a Sigmoid layer with #n_units# units.
    Sigmoid(int n_units);

    //-----

    virtual int numberOfParams();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);

    virtual ~Sigmoid();
};

#endif
