#include "SumMachine.h"


SumMachine::SumMachine(int n_units,int n_machines_)
{
  n_machines = n_machines_;
  n_inputs = n_units * n_machines;
  n_outputs = n_units;
}

int SumMachine::numberOfParams()
{
  return(0);
}

void SumMachine::forward(List *inputs)
{
  real *ptr_out = (real *)outputs->ptr;
  for (int i=0;i<n_outputs;i++)
    *ptr_out++ = 0;
  ptr_out = (real *)outputs->ptr;
  int i=0;
  while(inputs)
  {
    real *x = (real *)inputs->ptr;
    for(int j = 0; j < inputs->n; j++,i++)
      *ptr_out++ += *x++;
    if (i%n_outputs == 0)
      ptr_out = (real *)outputs->ptr;
    inputs = inputs->next;
  }
}

void SumMachine::backward(List *inputs, real *alpha)
{
  real *beta_ptr = beta;
  for (int i=0;i<n_machines;i++) {
    real *alpha_ptr = alpha;
    for (int j=0;j<n_outputs;j++)
      *beta_ptr++ = *alpha_ptr++; 
  }
}

SumMachine::~SumMachine()
{
}
