
#ifndef SUM_MACHINE_INC
#define SUM_MACHINE_INC

#include "GradientMachine.h"

/** This machine simply adds up its input vectors. Formally speaking,
    $outputs[i] = \sum_j inputs_j[i]$ where $i$ spans the size of the
    vectors and $j$ spans the number of input vectors.

    @author Samy Bengio (bengio@idiap.ch)
*/
class SumMachine : public GradientMachine
{
  public:

    /// the number of input vectors
    int n_machines;

    /// 
    SumMachine(int n_units, int n_machines_);

    virtual int numberOfParams();
    virtual void forward(List *inputs);
    virtual void backward(List *inputs, real *alpha);

    virtual ~SumMachine();
};

#endif
