#include "Tanh.h"

Tanh::Tanh(int n_units)
{
  n_inputs = n_units;
  n_outputs = n_units;
}

int Tanh::numberOfParams()
{
  return(0);
}

void Tanh::forward(List *inputs)
{
  real *ptr_out = (real *)outputs->ptr;
  while(inputs)
  {
    real *x = (real *)inputs->ptr;
    for(int j = 0; j < inputs->n; j++)
      *ptr_out++ = tanh(*x++);
    inputs = inputs->next;
  }
}

void Tanh::backward(List *inputs, real *alpha)
{
  real *alpha_ptr = alpha;
  real *beta_ptr = beta;
  real *out_ptr = (real *)outputs->ptr;
  for(int i = 0; i < n_outputs; i++)
  {
    real z = *out_ptr++;
    *beta_ptr++ = *alpha_ptr++ * (1. - z*z);
  }
}

Tanh::~Tanh()
{
}
