#include "general.h"

/** Compute means and variances for normalizing a matrix.
    Returns in
    \begin{itemize}
      \item #mean_buff# means table of each columns of #tab#.
      \item #std_buff# the standard deviations table.
    \end{itemize}
      
    Note: the memory allocation is not made by this function.

    #n_ex# is the number of examples in #tab#, and #n_dim# is
    the dimension of each example.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
void MSTDVNormalize(real **tab, real *mean_buff, real *std_buff, int n_ex, int n_dim);

/** Compute means and variances for normalizing a \emph{sparse} matrix.
    Returns in
    \begin{itemize}
      \item #mean_buff# means table of each columns of #tab#.
      \item #std_buff# the standard deviations table.
    \end{itemize}
      
    Note: the memory allocation is not made by this function.

    #n_ex# is the number of examples in #tab#, and #n_dim# is
    the dimension of each example.

    @author Ronan Collobert (collober@iro.umontreal.ca)
*/
void MSTDVSparseNormalize(sreal **tab, real *mean_buff, real *std_buff, int n_ex, int n_dim);
