#ifndef MX_LOW_LEVEL_INC
#define MX_LOW_LEVEL_INC

#include "general.h"
#define VUNROLL

/*  Collection of low level functions.
    Based on the "Meschach Library", available at the
    anonymous ftp site thrain.anu.edu.au in the directory
    pub/meschach.

    @author David E. Stewart (david.stewart@anu.edu.au)
    @author Zbigniew Leyk (zbigniew.leyk@anu.edu.au)
    @author Ronan Collobert (collober@iro.umontreal.ca)
*/

// Inner product
real mxIp__(real * dp1, real * dp2, int len);
// Scalar multiply and add c.f. v_mltadd()
void mxRealMulAdd__(real * dp1, real * dp2, real s, int len);
// Scalar multiply array c.f. sv_mlt()
void mxRealMul__(real * dp, real s, real * out, int len);
// Add arrays c.f. v_add()
void mxAdd__(real * dp1, real * dp2, real * out, int len);
// Subtract arrays c.f. v_sub()
void mxSub__(real * dp1, real * dp2, real * out, int len);
// Zeros an array of floating point numbers
void mxZero__(real * dp, int len);

#endif
