/*
        mem.cc
	
	Copyright (C) 2002 Sebastien Marcel (marcel@idiap.ch)

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>

float **floatMatrixAlloc(int N, int M)
{
	float **p;
  	int i, j;
 
	p = NULL;
	p = (float **) malloc(N * sizeof(float *));
	if(p == NULL) return NULL;

  	for(i = 0 ; i < N ; i++)
	{
		p[i] = (float *) malloc(M * sizeof(float));
		
		if(p[i] == NULL)
		{
			for(j = 0 ; j < i ; j++) 
			{
				free(p[j]);

				p[i] = NULL;				  
			}
			 
			free(p);
			 
			return NULL;			 
		}	
	}
	
/*
  	p = new float* [N];
  	if(p == NULL) return NULL;  
  
  	for(i = 0 ; i < N ; i++)
	{
		p[i] = new float [M];
		
		if(p[i] == NULL)
		{
			for(j = 0 ; j < i ; j++) 
			{
				delete [] p[j];

				p[i] = NULL;				  
			}
			 
			delete [] p;
			 
			return NULL;			 
		}		
	}
*/
	return p;  
}


void floatMatrixDelete(float ***p_, int N, int M)
{
  	int i;
 
	float **p = *p_;
	
  	if(p != NULL)
	{		
		for(i = 0 ; i < N ; i++) 
		{
//			delete [] p[i];
			free(p[i]);

			p[i] = NULL;			 
		}		
		
//		delete [] p;
		free(p);
		
		p = NULL;		
	}

	*p_ = p;
}



