/*
        saveppm.cc
	
	Copyright (C) 2002 Sebastien Marcel (marcel@idiap.ch)

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>

int SavePPM(char *filename, int w, int h, short *frame)
{
	FILE *pf;
  	int i, j, pix;
  	unsigned char c;
  	int iOffset;	
  	int gPlane;
  	int bPlane;
  
  	pf = fopen(filename, "w");
  
  	if(pf == NULL)
	{
		printf("Error: impossible to save file %s\n", filename);
		
		return 0;
	}
  	
	fprintf(pf, "P6\n");
	fprintf(pf, "# (c) 2002 - IDIAP\n");
	fprintf(pf, "# Image created by Sebastien MARCEL\n");
	fprintf(pf, "%d %d\n", w, h);
  	fprintf(pf, "255\n");
  
  	iOffset = 0;	
  	gPlane= w*h;
  	bPlane= 2 * gPlane;
  
  	for(i = 0 ; i < h ; i++) // Foreach lines
	{	    
		for(j = 0 ; j < w ; j++) // Foreach columns
		{
			pix = iOffset + j;		
			c = (unsigned char) frame[pix];	
			fwrite(&c, sizeof(unsigned char), 1, pf);
			 
			pix = iOffset + j + gPlane;		
			c = (unsigned char) frame[pix];		
			fwrite(&c, sizeof(unsigned char), 1, pf);
			 
			pix = iOffset + j + bPlane;		
			c = (unsigned char) frame[pix];		
			fwrite(&c, sizeof(unsigned char), 1, pf);
		}
		
		iOffset += w;
	}
  
	printf("\n");
  
	fclose(pf);
  
	return 1;
}

